summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorLibravatar Eric Sunshine <sunshine@sunshineco.com>2020-08-09 13:42:09 -0400
committerLibravatar Junio C Hamano <gitster@pobox.com>2020-08-09 12:13:02 -0700
commitd572f52a64c6a69990f72ad6a09504b9b615d2e4 (patch)
tree3ab28ec3e36841c624a30835e52f675e96e4350a
parentGit 2.28 (diff)
downloadtgif-d572f52a64c6a69990f72ad6a09504b9b615d2e4.tar.xz
test_cmp: diagnose incorrect arguments
Under normal circumstances, if a test author misspells a filename passed to test_cmp(), the error is quickly discovered when the test fails unexpectedly due to test_cmp() being unable to find the file. However, if the test is expected to fail, as with test_expect_failure(), a misspelled filename as argument to test_cmp() will go unnoticed since the test will indeed fail, but for the wrong reason. Make it easier for test authors to discover such problems early by sanity-checking the arguments to test_cmp(). To avoid penalizing all clients of test_cmp() in the general case, only check for missing files if the comparison fails. While at it, make test_cmp_bin() sanity-check its arguments, as well. Signed-off-by: Eric Sunshine <sunshine@sunshineco.com> Signed-off-by: Junio C Hamano <gitster@pobox.com>
-rw-r--r--t/test-lib-functions.sh16
1 files changed, 14 insertions, 2 deletions
diff --git a/t/test-lib-functions.sh b/t/test-lib-functions.sh
index 3103be8a32..21225330c2 100644
--- a/t/test-lib-functions.sh
+++ b/t/test-lib-functions.sh
@@ -905,7 +905,13 @@ test_expect_code () {
# - not all diff versions understand "-u"
test_cmp() {
- eval "$GIT_TEST_CMP" '"$@"'
+ test $# -eq 2 || BUG "test_cmp requires two arguments"
+ if ! eval "$GIT_TEST_CMP" '"$@"'
+ then
+ test "x$1" = x- || test -e "$1" || BUG "test_cmp '$1' missing"
+ test "x$2" = x- || test -e "$2" || BUG "test_cmp '$2' missing"
+ return 1
+ fi
}
# Check that the given config key has the expected value.
@@ -934,7 +940,13 @@ test_cmp_config() {
# test_cmp_bin - helper to compare binary files
test_cmp_bin() {
- cmp "$@"
+ test $# -eq 2 || BUG "test_cmp_bin requires two arguments"
+ if ! cmp "$@"
+ then
+ test "x$1" = x- || test -e "$1" || BUG "test_cmp_bin '$1' missing"
+ test "x$2" = x- || test -e "$2" || BUG "test_cmp_bin '$2' missing"
+ return 1
+ fi
}
# Use this instead of test_cmp to compare files that contain expected and